<template>
  <div class="details-plot-area d-flex flex-grow-1 flex-column">
    <template v-if="loading">
      <div class="d-flex flex-grow-1">
        <div class="mx-auto my-4">
          <h2 class="text-center mt-4">A carregar...</h2>
          <span class="align-middle">
            <clip-loader :loading="loading" color="#007bff" size="50px" radius="100%"/>
          </span>
        </div>
      </div>
    </template>
    <template v-else>
      <div class="chart-container">
        <base-chart ref="chart" :styles="chartStyle()" :options="chartOptions" :chart-data="chartData"/>
      </div>
    </template>
  </div>
</template>

<script>
import axios from 'axios'
import ClipLoader from 'vue-spinner/src/ClipLoader'
import BaseChart from '@/core/charts/mixins/BaseChart'
import { DEFAULT_CHART_OPTIONS } from '@/plots/chart'
import axisList from '@/plots/settings/axis'

export default {
  name: 'StationPlotArea',

  components: {
    ClipLoader,
    BaseChart
  },

  data () {
    return {
      data: null,
      loading: true
    }
  },

  props: {
    plotVariables: {
      type: Array,
      required: true
    }
  },

  computed: {
    stationId: {
      get () {
        return this.$route.params.station
      }
    },

    chartOptions: {
      get () {
        let options = {
          ...DEFAULT_CHART_OPTIONS,
        }

        options.scales.yAxes = this.plotVariables.map(variable => {
          return variable.axis
        }).filter((axis, index, arr) => {
          return arr.indexOf(axis) === index
        }).map((axis, index) => {
          return {
            ...this.getAxis(axis),
            position: index % 2 === 0 ? 'left' : 'right'
          }
        })

        return options
      }
    },

    chartData: {
      get () {
        const datasets = []

        this.plotVariables.forEach(variable => {
          datasets.push({
            ...variable.settings,
            data: this.data[variable.name].map(item => {
              return { t: item.time, y: item.value }
            })
          })
        })

        return {
          datasets
        }
      }
    }
  },

  methods: {
    chartStyle () {
      return { height: '300px', position: 'relative' }
    },

    getAxis (name) {
      return Object.values(axisList).find(axis => {
        return axis.id === name
      })
    }
  },

  async mounted () {
    const response = await axios.get(process.env.VUE_APP_BASE_STATION_QUERY_URL + '/' + this.stationId)
    this.data = response.data.properties
    this.loading = false
  }
}
</script>
